package com.hd.live.wall.wallpapers.pages;


import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.paging.PagingSource;
import androidx.paging.PagingState;

import com.hd.live.wall.wallpapers.dbData.WallData;
import com.hd.live.wall.wallpapers.utils.dbManager;

import java.util.List;

import kotlin.coroutines.Continuation;

public class PageSourceMain extends PagingSource<Integer, WallData> {
     public static int pageSize = 20;
    private int wallpaperType;

    public PageSourceMain(int wallpaperType) {
        this.wallpaperType = wallpaperType;
    }

    @Nullable
    @Override
    public Integer getRefreshKey(@NonNull PagingState<Integer, WallData> pagingState) {
        return null;
    }

    @Nullable
    @Override
    public Object load(@NonNull LoadParams<Integer> loadParams, @NonNull Continuation<? super LoadResult<Integer, WallData>> continuation) {

        try {
            int page = loadParams.getKey() != null ? loadParams.getKey() : 1;

            List<WallData> data = dbManager.queryData(wallpaperType,page);
//            Common.logMsg("-----load---------"+wallpaperType+"----page="+page+"'--data="+data.size());
            return new LoadResult.Page<>(
                    data,
                    page > 1 ? page - 1 : null,
                    data.isEmpty() ? null : page + 1
            );
        } catch (Exception e) {
            return new LoadResult.Error<>(e);
        }
    }
}

